<%@ page language="java" contentType="text/html; charset=utf-8"
	pageEncoding="utf-8"%>
<!DOCTYPE html>
<html lang="pl">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="description" content="HTML5 canvas - dataURL" />
<meta name="keywords" content="HTML5, canvas, dataURL">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" type="text/css" href="styles/opta.css" />
<title>HTML5 canvas - dataURL</title>
</head>
<body>
	<section>
		<header id="header">
			<a href="index.html"><img border="0" src="images/samsmok.png"
				width="120" height="130"
				alt="Zielony smok: powrót do strony głównej"
				title="Zielony Smok: Powrót do strony głównej"></a>
		</header>
		<h2 class="derby">Przesłanie dataURL na serwer</h2>
		<p>Sposób postępowania</p>
		<ul>
			<li>Obrazek na <code>canvas</code> zapisujemy do zmiennej przy
				użyciu <code>toDataURL()</code></li>
			<li>Przygotowujemy serwlet
				<ul>
					<li>Przygotowujemy serwlet przyjmujący dane i umieszczamy go
						na serwerze. Na razie serwlet zapisuje dane do zmiennej i
						przekazuje je z powrotem jako odpowiedź.</li>
					<li>Rejestrujemy serwlet w pliku 'web.xml'</li>
				</ul>
			</li>
			<li>Przygotowujemy kod AJAX do wysyłania zmiennej dataURL na
				serwer.</li>
			<li>Uruchamiamy kod przez kliknięcie przycisku 'Wyślij dataURL'.</li>
		</ul>
		<canvas id="canvas" width="240" height="240"
			style="border: 1px solid #238E3E;"></canvas>
		<input type="button" id="wyslij" value="Wyślij dataURL"
			onClick="sendDataURL()">
		<div id="dataURLdiv"></div>                
		<script type="text/javascript">
			var cv = document.getElementById('canvas');
			var ctx = cv.getContext('2d');
			var width = cv.width;
			var height = cv.height;
			ctx.beginPath();
			ctx.lineWidth = 5;
			ctx.fillStyle = "rgb(255,0,0)";
			drawHeart(ctx, 20, 20, 200, 200);
			ctx.fill();
			var obrazek = document.getElementById("obrazek");
			var dataURL = cv.toDataURL();
			function drawHeart(ctx, x, y, w, h) {
				var x0 = x + 0.5 * w;
				var y0 = y + 0.3 * h;
				var x1 = x + 0.1 * w;
				var y1 = y; //+ 0 * h
				var x2 = x; //+ 0 * w
				var y2 = y + 0.6 * h;
				var x3 = x + 0.5 * w;
				var y3 = y + 0.9 * h;
				var x4 = x + 1 * w;
				var y4 = y + 0.6 * h;
				var x5 = x + 0.9 * w;
				var y5 = y; //+ 0 * h			
				ctx.moveTo(x0, y0);
				ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
				ctx.bezierCurveTo(x4, y4, x5, y5, x0, y0);
			};
			var httpRequest;
			function sendDataURL() {
				dataURL = cv.toDataURL();
				httpRequest = new XMLHttpRequest();
				httpRequest.onreadystatechange = handleResponse;
				httpRequest.open("GET", "/dataURL2/dataURL2?dataURL="	+ escape(dataURL), true);
				httpRequest.setRequestHeader("Cache-Control", "no-cache");
				httpRequest.send();
			};
			var handleResponse = function() {
				if (httpRequest.readyState === 4 && httpRequest.status === 200) {
					document.getElementById("dataURLdiv").innerHTML = httpRequest.responseText;

				}
			};
		</script>
		<p>
			Uwagi:<br> Ponieważ zmienna dataURL zawiera łańcuch znaków można
			ją też przekazać na serwer przy użyciu formatu JSON.
		</p>
		<p class="listing">Listing</p>
		<pre>
var cv = document.getElementById('canvas');
var ctx = cv.getContext('2d');
var width = cv.width;
var height = cv.height;
ctx.beginPath();
ctx.lineWidth = 5;
ctx.fillStyle = "rgb(255,0,0)";
drawHeart(ctx, 20, 20, 200, 200);
ctx.fill();		
var obrazek = document.getElementById("obrazek");
var dataURL = cv.toDataURL();
	function drawHeart(ctx, x, y, w, h) {
		var x0 = x + 0.5 * w;
		var y0 = y + 0.3 * h;
		var x1 = x + 0.1 * w;
		var y1 = y //+ 0 * h;
		var x2 = x //+ 0 * w;
		var y2 = y + 0.6 * h;
		var x3 = x + 0.5 * w;
		var y3 = y + 0.9 * h;
		var x4 = x + 1 * w;
		var y4 = y + 0.6 * h;
		var x5 = x + 0.9 * w;
		var y5 = y //+ 0 * h;			
		ctx.moveTo(x0, y0);
		ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
		ctx.bezierCurveTo(x4, y4, x5, y5, x0, y0);
	};			
	var httpRequest;
	function sendDataURL(){
		dataURL = cv.toDataURL();			
		httpRequest = new XMLHttpRequest();
		httpRequest.onreadystatechange = handleResponse;
		httpRequest.open("GET", "/dataURL2/dataURL2?dataURL="+escape(dataURL), true);
		httpRequest.setRequestHeader("Cache-Control", "no-cache");
		httpRequest.send();
	};			
	var handleResponse = function() {
		if (httpRequest.readyState == 4 &amp;&amp; httpRequest.status == 200) {
			document.getElementById("dataURLdiv").innerHTML = httpRequest.responseText;				
			
		}
	};
								
            </pre>
		<p>Serwlet musimy zarejestrować w pliku web.xml. A oto sam serwlet</p>
		<pre>
package dataurls;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class DataUrlServlet2 extends HttpServlet{
	private static final long serialVersionUID = 7772065702934658508L;

	protected void process(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		String dataURL = request.getParameter("dataURL");
		  PrintWriter pw = new PrintWriter("C:\\Users\\Jacek\\eclipse-workspace\\canvas1\\WebContent\\dataURL.txt");
		pw.print(dataURL);
		pw.flush();
		pw.close();
		response.setContentType("blob");
		response.setHeader("Cache-Control", "no-cache");
		response.setCharacterEncoding("utf-8");
		response.getWriter().write(dataURL);
	}

	@Override
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		process(request, response);
	}

	@Override
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		process(request, response);
	}

	@Override
	public String getServletInfo() {
		return "Pobiera dane w postaci łańcucha znaków Base64.";
	}
}
            </pre>
	</section>
</body>
</html>